use std::io::{BufReader, BufRead};
use std::fs::File;

use color_eyre::eyre;


pub fn iter_nums(filename: &str) -> eyre::Result< impl Iterator<Item=eyre::Result<i32>> > {
    let file = File::open(filename)?;
    let reader = BufReader::new(file);

    let it = reader.lines().map(|line| 
        Ok(line?.parse::<i32>()?)
    );
    Ok(it)
}